/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables;


import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.processing.Generated;

import nu.studer.sample.Keys;
import nu.studer.sample.Selfbooster;
import nu.studer.sample.tables.records.TaskRecord;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row8;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Task extends TableImpl<TaskRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>selfbooster.task</code>
     */
    public static final Task TASK = new Task();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TaskRecord> getRecordType() {
        return TaskRecord.class;
    }

    /**
     * The column <code>selfbooster.task.uuid</code>.
     */
    public final TableField<TaskRecord, java.util.UUID> UUID = createField(DSL.name("uuid"), SQLDataType.UUID.nullable(false).defaultValue(DSL.field("uuid_generate_v4()", SQLDataType.UUID)), this, "");

    /**
     * The column <code>selfbooster.task.parent_task_uuid</code>. uuid
     * родительской задачи
     */
    public final TableField<TaskRecord, java.util.UUID> PARENT_TASK_UUID = createField(DSL.name("parent_task_uuid"), SQLDataType.UUID, this, "uuid родительской задачи");

    /**
     * The column <code>selfbooster.task.description</code>.
     */
    public final TableField<TaskRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>selfbooster.task.created_at</code>.
     */
    public final TableField<TaskRecord, Date> CREATED_AT = createField(DSL.name("created_at"), SQLDataType.DATE.defaultValue(DSL.field("CURRENT_DATE", SQLDataType.DATE)), this, "");

    /**
     * The column <code>selfbooster.task.desired_at</code>.
     */
    public final TableField<TaskRecord, Date> DESIRED_AT = createField(DSL.name("desired_at"), SQLDataType.DATE, this, "");

    /**
     * The column <code>selfbooster.task.due_at</code>.
     */
    public final TableField<TaskRecord, Date> DUE_AT = createField(DSL.name("due_at"), SQLDataType.DATE, this, "");

    /**
     * The column <code>selfbooster.task.percent</code>. процент выполнения
     */
    public final TableField<TaskRecord, Double> PERCENT = createField(DSL.name("percent"), SQLDataType.DOUBLE, this, "процент выполнения");

    /**
     * The column <code>selfbooster.task.purpose_uuid</code>.
     */
    public final TableField<TaskRecord, java.util.UUID> PURPOSE_UUID = createField(DSL.name("purpose_uuid"), SQLDataType.UUID, this, "");

    private Task(Name alias, Table<TaskRecord> aliased) {
        this(alias, aliased, null);
    }

    private Task(Name alias, Table<TaskRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>selfbooster.task</code> table reference
     */
    public Task(String alias) {
        this(DSL.name(alias), TASK);
    }

    /**
     * Create an aliased <code>selfbooster.task</code> table reference
     */
    public Task(Name alias) {
        this(alias, TASK);
    }

    /**
     * Create a <code>selfbooster.task</code> table reference
     */
    public Task() {
        this(DSL.name("task"), null);
    }

    public <O extends Record> Task(Table<O> child, ForeignKey<O, TaskRecord> key) {
        super(child, key, TASK);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Selfbooster.SELFBOOSTER;
    }

    @Override
    public UniqueKey<TaskRecord> getPrimaryKey() {
        return Keys.PK_TASKS_ID;
    }

    @Override
    public List<UniqueKey<TaskRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UNQ_TASKS_PURPOSE_ID);
    }

    @Override
    public List<ForeignKey<TaskRecord, ?>> getReferences() {
        return Arrays.asList(Keys.TASK__FK_TASKS_PURPOSE);
    }

    private transient Purpose _purpose;

    public Purpose purpose() {
        if (_purpose == null)
            _purpose = new Purpose(this, Keys.TASK__FK_TASKS_PURPOSE);

        return _purpose;
    }

    @Override
    public Task as(String alias) {
        return new Task(DSL.name(alias), this);
    }

    @Override
    public Task as(Name alias) {
        return new Task(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Task rename(String name) {
        return new Task(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Task rename(Name name) {
        return new Task(name, null);
    }

    // -------------------------------------------------------------------------
    // Row8 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row8<java.util.UUID, java.util.UUID, String, Date, Date, Date, Double, java.util.UUID> fieldsRow() {
        return (Row8) super.fieldsRow();
    }
}
